#-------------------------------------------
# Build Docker Image from a GitLab Project
#-------------------------------------------
stages:
  - 🚧build-img
  - 🚧tests

🐳build:latest:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  stage: 🚧build-img
  only:
    refs:
      - master
  script: |
    echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR \
      --dockerfile $CI_PROJECT_DIR/Dockerfile \
      --destination $CI_REGISTRY_IMAGE:latest

🐳build:mr:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  stage: 🚧build-img
  only:
    refs:
      - merge_requests
  script: |
    echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR \
      --dockerfile $CI_PROJECT_DIR/Dockerfile \
      --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

🐳build:tag:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  stage: 🚧build-img
  only:
    - tags
  script: |
    echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR \
      --dockerfile $CI_PROJECT_DIR/Dockerfile \
      --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME

run:cmd:
  image: registry.gitlab.com/tanuki-workshops/kube-demos/vulnerabilitiy-analyzers/horusec-kotlin:latest
  stage: 🚧tests
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: manual
    - if: $CI_MERGE_REQUEST_IID
      when: manual
  script: |
    ls
    horusec-kotlin run -p sample/src -o output.json && cat output.json

run:analyze:
  image: registry.gitlab.com/tanuki-workshops/kube-demos/vulnerabilitiy-analyzers/horusec-kotlin:latest
  stage: 🚧tests
  #rules:
  #  - if: $CI_COMMIT_BRANCH == "master"
  #    when: manual
  #  - if: $CI_MERGE_REQUEST_IID
  #    when: manual
  script: |
    analyze sample/src
    cat ./gl-sast-report.json



